Loading...
Searching...
No Matches
IDableGraphComponent< BAS > Class Template Reference

## Detailed Description

template<typename BAS = BaseGraphComponent>
class lemon::concepts::IDableGraphComponent< BAS >

This class describes the interface of idable undirected graphs. It extends IDableDigraphComponent with the core ID functions of undirected graphs. The ids of the items must be unique and immutable. This concept is part of the Graph concept.

`#include <lemon/concepts/graph_components.h>`

Inheritance diagram for IDableGraphComponent< BAS >:
[legend]

## Public Member Functions

int | id (const Edge &) const
| Return a unique integer id for the given edge.
Edge | edgeFromId (int) const
| Return the edge by its unique id.
int | maxEdgeId () const
| Return an integer greater or equal to the maximum edge id.
Public Member Functions inherited from IDableDigraphComponent< BaseGraphComponent >
int | id (const Node &) const
| Return a unique integer id for the given node.
Node | nodeFromId (int) const
| Return the node by its unique id.
Arc | arcFromId (int) const
| Return the arc by its unique id.
int | maxNodeId () const
| Return an integer greater or equal to the maximum node id.
int | maxArcId () const
| Return an integer greater or equal to the maximum arc id.
Public Member Functions inherited from BaseGraphComponent
Node | u (const Edge &) const
| Return one end node of an edge.
Node | v (const Edge &) const
| Return the other end node of an edge.
Arc | direct (const Edge &, bool) const
| Return a directed arc related to an edge.
Arc | direct (const Edge &, const Node &) const
| Return a directed arc related to an edge.
bool | direction (const Arc &) const
| Return the direction of the arc.
Arc | oppositeArc (const Arc &) const
| Return the opposite arc.
Public Member Functions inherited from BaseDigraphComponent
Node | source (const Arc &) const
| Return the source node of an arc.
Node | target (const Arc &) const
| Return the target node of an arc.
Node | oppositeNode (const Node &, const Arc &) const
| Return the opposite node on the given arc.

## Additional Inherited Members

Public Types inherited from BaseDigraphComponent
typedef GraphItem< 'n'> | Node
| Node class of the digraph.
typedef GraphItem< 'a'> | Arc
| Arc class of the digraph.

## Member Function Documentation

## id()

template<typename BAS = BaseGraphComponent>

int id | ( | const Edge & |  | ) | const

inline

This function returns a unique integer id for the given edge.

## edgeFromId()

template<typename BAS = BaseGraphComponent>

Edge edgeFromId | ( | int |  | ) | const

inline

This function returns the edge by its unique id. If the graph does not contain an edge with the given id, then the result of the function is undefined.

## maxEdgeId()

template<typename BAS = BaseGraphComponent>

int maxEdgeId | ( |  | ) | const

inline

This function returns an integer greater or equal to the maximum edge id.